﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SqlXmlVsDocumentDb.Models
{
    public class Customer
    {
        [JsonProperty("id")]
        public string Id { get; set; }

        public List<Consumption> Consumptions { get; set; }

        public static Customer GenerateCustomer()
        {
            var rnd = new Random();

            var customer = new Customer
            {
                Id = Guid.NewGuid().ToString(),
                Consumptions = new List<Consumption>(),
            };

            var day = 1;
            while (day <= 30)
            {
                customer.Consumptions.Add(new Consumption
                {
                    ConsumptionDay = day,
                    ConsumptionValue = rnd.Next(1, 10),
                });
                day += rnd.Next(1, 10);
            }

            return customer;
        }
    }
}
