﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Azure.Documents.Client;
using Microsoft.Azure.Documents.Linq;
using SqlXmlVsDocumentDb.Models;
using Microsoft.Azure.Documents;
using System.IO;

namespace SqlXmlVsDocumentDb
{
    class Program
    {
        static void Main(string[] args)
        {
            using (var client = new DocumentClient(Config.ServiceEndpoint, Config.AuthKey))
            {
                //CarManufacturer_Prepare(client).Wait();
                //CarManufacturer_RunQueries(client).Wait();
                //CarManufacturer_Update(client).Wait();

                //CustomerConsumption_Prepare(client).Wait();
                //CustomerConsumption_RunQueries(client).Wait();

                //StoredProcedure_Create(client).Wait();
                //StoredProcedure_ExecuteHelloWorld(client).Wait();
                //StoredProcedure_ExecuteCreateDoc(client).Wait();
            }
            Console.WriteLine("<Press any key to close>");
            Console.ReadKey();
        }

        #region Car Manufacturers

        public static async Task CarManufacturer_Prepare(DocumentClient client)
        {
            var helper = new DocDbHelper(client);

            var database = await helper.GetOrCreateDatabaseAsync("SQLSat409");
            var collection = await helper.GetOrCreateDocumentCollectionAsync(database, "CarManufacturer");

            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1021, Comment = "info 1021 customer since 2010", CompanyName = "Alfa Romeo", CustomerSince = 2010 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1022, Comment = "info 1022 customer since 2010", CompanyName = "Aston Martin", CustomerSince = 2010 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1023, Comment = "info 1023 customer since 2010", CompanyName = "Audi", CustomerSince = 2010 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1024, Comment = "info 1024 customer since 2010", CompanyName = "Bentley", CustomerSince = 2010 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1025, Comment = "info 1025 customer since 2010", CompanyName = "BMW", CustomerSince = 2010 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1026, Comment = "info 1026 customer since 2010", CompanyName = "Bugatti", CustomerSince = 2010 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1027, Comment = "info 1027 customer since 2010", CompanyName = "Chevrolet", CustomerSince = 2010 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1028, Comment = "info 1028 customer since 2010", CompanyName = "Chrysler", CustomerSince = 2010 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1029, Comment = "info 1029 customer since 2010", CompanyName = "Citroën", CustomerSince = 2010 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1030, Comment = "info 1030 customer since 2010", CompanyName = "Dacia", CustomerSince = 2010 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1031, Comment = "info 1031 customer since 2010", CompanyName = "Daihatsu", CustomerSince = 2010 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1032, Comment = "info 1032 customer since 2010", CompanyName = "Ferrari", CustomerSince = 2010 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1033, Comment = "info 1033 customer since 2010", CompanyName = "Fiat", CustomerSince = 2010 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1034, Comment = "info 1034 customer since 2010", CompanyName = "Ford", CustomerSince = 2010 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1035, Comment = "info 1035 customer since 2010", CompanyName = "Honda", CustomerSince = 2010 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1036, Comment = "info 1036 customer since 2012", CompanyName = "Hyundai", CustomerSince = 2012 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1037, Comment = "info 1037 customer since 2012", CompanyName = "Infiniti", CustomerSince = 2012 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1038, Comment = "info 1038 customer since 2012", CompanyName = "Jaguar", CustomerSince = 2012 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1039, Comment = "info 1039 customer since 2012", CompanyName = "Kia", CustomerSince = 2012 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1040, Comment = "info 1040 customer since 2012", CompanyName = "Lada", CustomerSince = 2012 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1041, Comment = "info 1041 customer since 2012", CompanyName = "Lamborghini", CustomerSince = 2012 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1042, Comment = "info 1042 customer since 2012", CompanyName = "Lancia", CustomerSince = 2012 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1043, Comment = "info 1043 customer since 2012", CompanyName = "Land Rover", CustomerSince = 2012 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1044, Comment = "info 1044 customer since 2012", CompanyName = "Lexus", CustomerSince = 2012 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1045, Comment = "info 1045 customer since 2012", CompanyName = "Lotus", CustomerSince = 2012 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1046, Comment = "info 1046 customer since 2012", CompanyName = "Maserati", CustomerSince = 2012 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1047, Comment = "info 1047 customer since 2012", CompanyName = "Maybach", CustomerSince = 2012 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1048, Comment = "info 1048 customer since 2012", CompanyName = "Mazda", CustomerSince = 2012 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1049, Comment = "info 1049 customer since 2012", CompanyName = "Mercedes Benz", CustomerSince = 2012 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1050, Comment = "info 1050 customer since 2012", CompanyName = "Mini", CustomerSince = 2012 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1051, Comment = "info 1051 customer since 2014", CompanyName = "Mitsubishi", CustomerSince = 2014 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1052, Comment = "info 1052 customer since 2014", CompanyName = "Nissan", CustomerSince = 2014 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1053, Comment = "info 1053 customer since 2014", CompanyName = "Opel", CustomerSince = 2014 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1054, Comment = "info 1054 customer since 2014", CompanyName = "Peugeot", CustomerSince = 2014 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1055, Comment = "info 1055 customer since 2014", CompanyName = "Porsche", CustomerSince = 2014 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1056, Comment = "info 1056 customer since 2014", CompanyName = "Renault", CustomerSince = 2014 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1057, Comment = "info 1057 customer since 2014", CompanyName = "Rolls-Royce", CustomerSince = 2014 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1058, Comment = "info 1058 customer since 2014", CompanyName = "Saab", CustomerSince = 2014 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1059, Comment = "info 1059 customer since 2014", CompanyName = "Seat", CustomerSince = 2014 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1060, Comment = "info 1060 customer since 2014", CompanyName = "Skoda", CustomerSince = 2014 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1061, Comment = "info 1061 customer since 2014", CompanyName = "Smart", CustomerSince = 2014 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1062, Comment = "info 1062 customer since 2014", CompanyName = "Subaru", CustomerSince = 2014 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1063, Comment = "info 1063 customer since 2014", CompanyName = "Suzuki", CustomerSince = 2014 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1064, Comment = "info 1064 customer since 2014", CompanyName = "Tata", CustomerSince = 2014 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1065, Comment = "info 1065 customer since 2014", CompanyName = "Toyota", CustomerSince = 2014 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1066, Comment = "info 1066 customer since 2014", CompanyName = "Volkswagen", CustomerSince = 2014 });
            await helper.CreateDocumentAsync(collection, new CarManufacturer { CustomerID = 1067, Comment = "info 1067 customer since 2014", CompanyName = "Volvo", CustomerSince = 2014 });
        }

        private static async Task CarManufacturer_RunQueries(DocumentClient client)
        {
            var helper = new DocDbHelper(client);

            var database = await helper.GetOrCreateDatabaseAsync("SQLSat409");
            var collection = await helper.GetOrCreateDocumentCollectionAsync(database, "CarManufacturer");

            CarManufacturer_QueryAll(client, collection.DocumentsLink);
            CarManufacturer_QueryForCompanyName(client, collection.DocumentsLink, "Volkswagen");
            CarManufacturer_QueryForCustomerSince(client, collection.DocumentsLink, 2012);
            CarManufacturer_QuerySelected(client, collection.DocumentsLink);
        }

        private static void CarManufacturer_QueryAll(DocumentClient client, string collectionLink)
        {
            var manufacturers =
                from c in client.CreateDocumentQuery<CarManufacturer>(collectionLink)
                select c;

            foreach (var manufacturer in manufacturers)
            {
                Console.WriteLine("Found {0} (id: {1})", manufacturer.CompanyName, manufacturer.Id);
            }
            Console.WriteLine("===========================================================");
        }

        private static void CarManufacturer_QueryForCompanyName(DocumentClient client, string collectionLink, string name)
        {
            var manufacturers = client
                .CreateDocumentQuery<CarManufacturer>(collectionLink)
                .Where(c => c.CompanyName == name);

            foreach (var manufacturer in manufacturers)
            {
                Console.WriteLine("{0} is a customer since {1}",
                    manufacturer.CompanyName, manufacturer.CustomerSince);
            }
            Console.WriteLine("===========================================================");
        }

        private static void CarManufacturer_QueryForCustomerSince(DocumentClient client, string collectionLink, int customerSince)
        {
            var manufacturers = client
                .CreateDocumentQuery<CarManufacturer>(collectionLink,
                String.Format(
                "SELECT * FROM Manufacturer m WHERE m.CustomerSince = {0}",
                customerSince));

            foreach (var manufacturer in manufacturers)
            {
                Console.WriteLine("Customer {0} ({1})", manufacturer.CompanyName, manufacturer.Comment);
            }
            Console.WriteLine("===========================================================");
        }

        private static void CarManufacturer_QuerySelected(DocumentClient client, string collectionLink)
        {
            var manufacturers = client.CreateDocumentQuery(
                collectionLink, "SELECT m.CompanyName, m.CustomerSince FROM Manufacturer m WHERE m.CustomerSince = 2010")
                .ToList();

            foreach (var manufacturer in manufacturers)
            {
                Console.WriteLine("Customer {0} ({1})", manufacturer.CompanyName, manufacturer.CustomerSince);
            }
            Console.WriteLine("===========================================================");
        }

        private static async Task CarManufacturer_Update(DocumentClient client)
        {
            var helper = new DocDbHelper(client);

            var database = await helper.GetOrCreateDatabaseAsync("SQLSat409");
            var collection = await helper.GetOrCreateDocumentCollectionAsync(database, "CarManufacturer");

            // Before
            CarManufacturer_QueryForCompanyName(client, collection.DocumentsLink, "Chevrolet");

            var manufacturer = client
                .CreateDocumentQuery<CarManufacturer>(collection.DocumentsLink)
                .Where(c => c.CompanyName == "Chevrolet")
                .AsEnumerable()
                .First();
            manufacturer.CustomerSince = 2010;

            var conferenceDoc = client
                .CreateDocumentQuery(collection.DocumentsLink)
                .Where(c => c.Id == manufacturer.Id)
                .AsEnumerable()
                .First();
            await client.ReplaceDocumentAsync(conferenceDoc.SelfLink, manufacturer);

            // After
            CarManufacturer_QueryForCompanyName(client, collection.DocumentsLink, "Chevrolet");
        }

        #endregion

        #region Customer Consumptions

        public static async Task CustomerConsumption_Prepare(DocumentClient client)
        {
            var helper = new DocDbHelper(client);

            var database = await helper.GetOrCreateDatabaseAsync("SQLSat409").ConfigureAwait(false);
            var collection = await helper.GetOrCreateDocumentCollectionAsync(database, "CustomerConsumption").ConfigureAwait(false);

            for (int i = 0; i < 1000; i++)
            {
                await helper.CreateDocumentAsync(collection, Customer.GenerateCustomer()).ConfigureAwait(false);
            }
        }

        private static async Task CustomerConsumption_RunQueries(DocumentClient client)
        {
            var helper = new DocDbHelper(client);

            var database = await helper.GetOrCreateDatabaseAsync("SQLSat409");
            var collection = await helper.GetOrCreateDocumentCollectionAsync(database, "CustomerConsumption");

            //CustomerConsumption_QueryAll(client, collection.DocumentsLink);
            CustomerConsumption_Aggregate(client, collection.DocumentsLink);
        }

        private static void CustomerConsumption_QueryAll(DocumentClient client, string collectionLink)
        {
            var customers =
                from c in client.CreateDocumentQuery<Customer>(collectionLink)
                select c;

            foreach (var customer in customers)
            {
                Console.WriteLine("Found {0}", customer.Id);
            }
            Console.WriteLine("===========================================================");
        }

        private static void CustomerConsumption_Aggregate(DocumentClient client, string collectionLink)
        {
            var results = client
                .CreateDocumentQuery<Customer>(collectionLink)
                .ToList() // DocumentDB doesn't support Aggregation
                .Select(c => new
                {
                    CustomerId = c.Id,
                    ConsumptionCount = c.Consumptions.Count,
                    ConsumptionSum = c.Consumptions.Sum(v => v.ConsumptionValue),
                    ConsumptionAvg = c.Consumptions.Average(v => v.ConsumptionValue),
                })
                .Where(r => r.ConsumptionAvg >= 5);

            foreach (var result in results)
            {
                Console.WriteLine("{0}, {1}, {2}, {3}",
                    result.CustomerId, result.ConsumptionCount, result.ConsumptionSum, result.ConsumptionAvg);
            }
            Console.WriteLine("===========================================================");
        }

        #endregion

        #region Server Side Code

        private static async Task StoredProcedure_Create(DocumentClient client)
        {
            var helper = new DocDbHelper(client);

            var database = await helper.GetOrCreateDatabaseAsync("SQLSat409").ConfigureAwait(false);
            var collection = await helper.GetOrCreateDocumentCollectionAsync(database, "CustomerConsumption").ConfigureAwait(false);

            var mySproc = new StoredProcedure
            {
                Id = "helloWorld",
                Body = File.ReadAllText("StoredProcedures\\helloWorld.js")
            };
            await client.CreateStoredProcedureAsync(collection.DocumentsLink, mySproc);

            mySproc = new StoredProcedure
            {
                Id = "createMyDocument",
                Body = File.ReadAllText("StoredProcedures\\createMyDocument.js")
            };
            await client.CreateStoredProcedureAsync(collection.DocumentsLink, mySproc);
        }

        private static async Task StoredProcedure_ExecuteHelloWorld(DocumentClient client)
        {
            var helper = new DocDbHelper(client);

            var database = await helper.GetOrCreateDatabaseAsync("SQLSat409").ConfigureAwait(false);
            var collection = await helper.GetOrCreateDocumentCollectionAsync(database, "CustomerConsumption").ConfigureAwait(false);

            var sproc = client.CreateStoredProcedureQuery(collection.DocumentsLink)
                .Where(c => c.Id == "helloWorld")
                .AsEnumerable()
                .FirstOrDefault();

            var response = await client.ExecuteStoredProcedureAsync<string>(sproc.SelfLink);
            Console.WriteLine(response);
        }

        private static async Task StoredProcedure_ExecuteCreateDoc(DocumentClient client)
        {
            var helper = new DocDbHelper(client);

            var database = await helper.GetOrCreateDatabaseAsync("SQLSat409").ConfigureAwait(false);
            var collection = await helper.GetOrCreateDocumentCollectionAsync(database, "CustomerConsumption").ConfigureAwait(false);

            var sproc = client.CreateStoredProcedureQuery(collection.DocumentsLink)
                .Where(c => c.Id == "createMyDocument")
                .AsEnumerable()
                .FirstOrDefault();

            var customer = Customer.GenerateCustomer();

            var id = await client.ExecuteStoredProcedureAsync<string>(sproc.SelfLink, customer);
            Console.WriteLine(id);
        }

        #endregion
    }
}
